/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.247 Revision 1.348
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.247 2006/08/11 02:21:47 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.348 2010/07/11 17:29:10 betelgeuse Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# This eclass is for general purpose functions that most ebuilds 15# Due to the nature of this eclass, some functions may have maintainers
6# have to implement themselves. 16# different from the overall eclass!
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
15 21
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
18# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
19# must be an integer greater than zero. 25# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 31epause() {
22 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23} 33}
24 34
25# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
26# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
27# don't beep. 37# @DESCRIPTION:
28# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
29ebeep() { 42ebeep() {
30 local n 43 local n
31 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
32 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
33 echo -ne "\a" 46 echo -ne "\a"
36 sleep 1 49 sleep 1
37 done 50 done
38 fi 51 fi
39} 52}
40 53
41# This function generate linker scripts in /usr/lib for dynamic 54else
42# libs in /lib. This is to fix linking problems when you have
43# the .so in /lib, and the .a in /usr/lib. What happens is that
44# in some cases when linking dynamic, the .a in /usr/lib is used
45# instead of the .so in /lib due to gcc/libtool tweaking ld's
46# library search path. This cause many builds to fail.
47# See bug #4411 for more info.
48#
49# To use, simply call:
50#
51# gen_usr_ldscript libfoo.so
52#
53# Note that you should in general use the unversioned name of
54# the library, as ldconfig should usually update it correctly
55# to point to the latest version of the library present.
56#
57# <azarah@gentoo.org> (26 Oct 2002)
58#
59gen_usr_ldscript() {
60 local lib libdir=$(get_libdir)
61 # Just make sure it exists
62 dodir /usr/${libdir}
63 55
64 for lib in "${@}" ; do 56ebeep() {
65 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
66 /* GNU ld script 58}
67 Since Gentoo has critical dynamic libraries
68 in /lib, and the static versions in /usr/lib,
69 we need to have a "fake" dynamic lib in /usr/lib,
70 otherwise we run into linking problems.
71 59
72 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
73 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
74 GROUP ( /${libdir}/${lib} ) 62}
75 END_LDSCRIPT 63
76 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
116# return 0
117# fi
77 done 118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
78} 134}
79 135
136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
80 154
81# Default directory where patches are located 155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
82EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
83# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
84EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
85# Default options for patch 165# Default options for patch:
166# @CODE
86# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
87# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 168# --no-backup-if-mismatch - do not leave .orig files behind
88# Set -E to automatically remove empty files. 169# -E - automatically remove empty files
170# @CODE
89EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
90# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
91# and not the full path .. 175# and not the full path. Globs accepted.
92EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
93# Change the printed message for a single patch. 179# Change the printed message for a single patch.
94EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
95# Change the printed message for multiple patches. 183# Change the printed message for multiple patches.
96EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
97# Force applying bulk patches even if not following the style: 185# @VARIABLE: EPATCH_FORCE
98# 186# @DESCRIPTION:
99# ??_${ARCH}_foo.${EPATCH_SUFFIX} 187# Only require patches to match EPATCH_SUFFIX rather than the extended
100# 188# arch naming style.
101EPATCH_FORCE="no" 189EPATCH_FORCE="no"
102 190
103# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
104# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
105# 199#
106# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
107# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
108# 202#
109# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
110# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
111# 205# ${EPATCH_FORCE} == "yes"
112# Above EPATCH_* variables can be used to control various defaults,
113# bug they should be left as is to ensure an ebuild can rely on
114# them for.
115#
116# Patches are applied in current directory.
117#
118# Bulk Patches should preferibly have the form of:
119#
120# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
121# 215#
122# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
123# 218#
124# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
125# 02_sparc_another-fix.patch.bz2
126#
127# This ensures that there are a set order, and you can have ARCH
128# specific patches.
129#
130# If you however give an argument to epatch(), it will treat it as a
131# single patch that need to be applied if its a file. If on the other
132# hand its a directory, it will set EPATCH_SOURCE to this.
133#
134# <azarah@gentoo.org> (10 Nov 2002)
135#
136epatch() { 220epatch() {
137 _epatch_draw_line() { 221 _epatch_draw_line() {
222 # create a line of same length as input string
138 [[ -z $1 ]] && set "$(printf "%65s" '')" 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
139 echo "${1//?/=}" 224 echo "${1//?/=}"
140 } 225 }
141 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
142 local PIPE_CMD=""
143 local STDERR_TARGET="${T}/$$.out"
144 local PATCH_TARGET="${T}/$$.patch"
145 local PATCH_SUFFIX=""
146 local SINGLE_PATCH="no"
147 local x=""
148 226
149 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
150 228
151 if [ "$#" -gt 1 ] 229 # Let the rest of the code process one user arg at a time --
152 then 230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
153 local m="" 233 local m
154 for m in "$@" ; do 234 for m in "$@" ; do
155 epatch "${m}" 235 epatch "${m}"
156 done 236 done
157 return 0 237 return 0
158 fi 238 fi
159 239
160 if [ -n "$1" -a -f "$1" ] 240 local SINGLE_PATCH="no"
161 then 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
162 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
163 246 set -- "$1"
164 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
165 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
166 250
167 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
168 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
169 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
170 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 else
256 # sanity check ... if it isn't a dir or file, wtf man ?
257 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
258 echo
259 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
260 eerror
261 eerror " ${EPATCH_SOURCE}"
262 eerror " ( ${EPATCH_SOURCE##*/} )"
263 echo
264 die "Cannot find \$EPATCH_SOURCE!"
265 fi
266
267 local PIPE_CMD
268 case ${EPATCH_SUFFIX##*\.} in
269 xz) PIPE_CMD="xz -dc" ;;
270 lzma) PIPE_CMD="lzma -dc" ;;
271 bz2) PIPE_CMD="bzip2 -dc" ;;
272 gz|Z|z) PIPE_CMD="gzip -dc" ;;
273 ZIP|zip) PIPE_CMD="unzip -p" ;;
274 *) ;;
275 esac
276
277 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
278
279 local x
280 for x in "$@" ; do
281 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
282 # didn't match anything, ignore continue on
283 [[ ! -f ${x} ]] && continue
284
285 local patchname=${x##*/}
286
287 # Apply single patches, or forced sets of patches, or
288 # patches with ARCH dependant names.
289 # ???_arch_foo.patch
290 # Else, skip this input altogether
291 local a=${patchname#*_} # strip the ???_
292 a=${a%%_*} # strip the _foo.patch
293 if ! [[ ${SINGLE_PATCH} == "yes" || \
294 ${EPATCH_FORCE} == "yes" || \
295 ${a} == all || \
296 ${a} == ${ARCH} ]]
171 then 297 then
172 local EPATCH_SOURCE="$1/*" 298 continue
299 fi
300
301 # Let people filter things dynamically
302 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
303 # let people use globs in the exclude
304 eshopts_push -o noglob
305
306 local ex
307 for ex in ${EPATCH_EXCLUDE} ; do
308 if [[ ${patchname} == ${ex} ]] ; then
309 eshopts_pop
310 continue 2
311 fi
312 done
313
314 eshopts_pop
315 fi
316
317 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
318 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
319 einfo "${EPATCH_SINGLE_MSG}"
320 else
321 einfo "Applying ${patchname} ..."
322 fi
173 else 323 else
174 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 324 einfo " ${patchname} ..."
175 fi 325 fi
176 else 326
177 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 327 # most of the time, there will only be one run per unique name,
178 then 328 # but if there are more, make sure we get unique log filenames
179 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 329 local STDERR_TARGET="${T}/${patchname}.out"
180 then 330 if [[ -e ${STDERR_TARGET} ]] ; then
181 EPATCH_SOURCE="$1" 331 STDERR_TARGET="${T}/${patchname}-$$.out"
332 fi
333
334 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
335
336 # Decompress the patch if need be
337 local count=0
338 local PATCH_TARGET
339 if [[ -n ${PIPE_CMD} ]] ; then
340 PATCH_TARGET="${T}/$$.patch"
341 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
342
343 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
344 echo
345 eerror "Could not extract patch!"
346 #die "Could not extract patch!"
347 count=5
348 break
182 fi 349 fi
350 else
351 PATCH_TARGET=${x}
352 fi
183 353
354 # Check for absolute paths in patches. If sandbox is disabled,
355 # people could (accidently) patch files in the root filesystem.
356 # Or trigger other unpleasantries #237667. So disallow -p0 on
357 # such patches.
358 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
359 if [[ -n ${abs_paths} ]] ; then
360 count=1
361 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
362 fi
363
364 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
365 while [[ ${count} -lt 5 ]] ; do
366 # Generate some useful debug info ...
367 (
368 _epatch_draw_line "***** ${patchname} *****"
184 echo 369 echo
185 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 370 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
371 echo
372 _epatch_draw_line "***** ${patchname} *****"
373 ) >> "${STDERR_TARGET}"
374
375 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
376 (
377 _epatch_draw_line "***** ${patchname} *****"
378 echo
379 echo "ACTUALLY APPLYING ${patchname} ..."
380 echo
381 _epatch_draw_line "***** ${patchname} *****"
382 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
383 ) >> "${STDERR_TARGET}"
384
385 if [ $? -ne 0 ] ; then
386 echo
387 eerror "A dry-run of patch command succeeded, but actually"
388 eerror "applying the patch failed!"
389 #die "Real world sux compared to the dreamworld!"
390 count=5
391 fi
392 break
393 fi
394
395 : $(( count++ ))
396 done
397
398 # if we had to decompress the patch, delete the temp one
399 if [[ -n ${PIPE_CMD} ]] ; then
400 rm -f "${PATCH_TARGET}"
401 fi
402
403 if [[ ${count} -ge 5 ]] ; then
404 echo
405 eerror "Failed Patch: ${patchname} !"
406 eerror " ( ${PATCH_TARGET} )"
186 eerror 407 eerror
187 eerror " ${EPATCH_SOURCE}" 408 eerror "Include in your bugreport the contents of:"
188 eerror " ( ${EPATCH_SOURCE##*/} )" 409 eerror
410 eerror " ${STDERR_TARGET}"
189 echo 411 echo
190 die "Cannot find \$EPATCH_SOURCE!"
191 fi
192
193 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
194 fi
195
196 case ${EPATCH_SUFFIX##*\.} in
197 bz2)
198 PIPE_CMD="bzip2 -dc"
199 PATCH_SUFFIX="bz2"
200 ;;
201 gz|Z|z)
202 PIPE_CMD="gzip -dc"
203 PATCH_SUFFIX="gz"
204 ;;
205 ZIP|zip)
206 PIPE_CMD="unzip -p"
207 PATCH_SUFFIX="zip"
208 ;;
209 *)
210 PIPE_CMD="cat"
211 PATCH_SUFFIX="patch"
212 ;;
213 esac
214
215 if [ "${SINGLE_PATCH}" = "no" ]
216 then
217 einfo "${EPATCH_MULTI_MSG}"
218 fi
219 for x in ${EPATCH_SOURCE}
220 do
221 # New ARCH dependant patch naming scheme ...
222 #
223 # ???_arch_foo.patch
224 #
225 if [ -f ${x} ] && \
226 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
227 [ "${EPATCH_FORCE}" = "yes" ])
228 then
229 local count=0
230 local popts="${EPATCH_OPTS}"
231 local patchname=${x##*/}
232
233 if [ -n "${EPATCH_EXCLUDE}" ]
234 then
235 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
236 then
237 continue
238 fi
239 fi
240
241 if [ "${SINGLE_PATCH}" = "yes" ]
242 then
243 if [ -n "${EPATCH_SINGLE_MSG}" ]
244 then
245 einfo "${EPATCH_SINGLE_MSG}"
246 else
247 einfo "Applying ${patchname} ..."
248 fi
249 else
250 einfo " ${patchname} ..."
251 fi
252
253 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
254 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
255
256 # Allow for prefix to differ ... im lazy, so shoot me :/
257 while [ "${count}" -lt 5 ]
258 do
259 # Generate some useful debug info ...
260 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
261 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
262
263 if [ "${PATCH_SUFFIX}" != "patch" ]
264 then
265 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
267 else
268 PATCH_TARGET="${x}"
269 fi
270
271 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273
274 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276
277 if [ "${PATCH_SUFFIX}" != "patch" ]
278 then
279 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
280 then
281 echo
282 eerror "Could not extract patch!"
283 #die "Could not extract patch!"
284 count=5
285 break
286 fi
287 fi
288
289 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
290 then
291 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
292 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
293 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
294 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
295 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296
297 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
298 _epatch_assert
299
300 if [ "$?" -ne 0 ]
301 then
302 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
303 echo
304 eerror "A dry-run of patch command succeeded, but actually"
305 eerror "applying the patch failed!"
306 #die "Real world sux compared to the dreamworld!"
307 count=5
308 fi
309
310 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
311
312 break
313 fi
314
315 count=$((count + 1))
316 done
317
318 if [ "${PATCH_SUFFIX}" != "patch" ]
319 then
320 rm -f ${PATCH_TARGET}
321 fi
322
323 if [ "${count}" -eq 5 ]
324 then
325 echo
326 eerror "Failed Patch: ${patchname} !"
327 eerror " ( ${PATCH_TARGET} )"
328 eerror
329 eerror "Include in your bugreport the contents of:"
330 eerror
331 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
332 echo
333 die "Failed Patch: ${patchname}!" 412 die "Failed Patch: ${patchname}!"
334 fi 413 fi
335 414
336 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 415 # if everything worked, delete the patch log
337 416 rm -f "${STDERR_TARGET}"
338 eend 0 417 eend 0
339 fi
340 done 418 done
341 if [ "${SINGLE_PATCH}" = "no" ] 419
342 then 420 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
343 einfo "Done with patching" 421 : # everything worked
422}
423epatch_user() {
424 [[ $# -ne 0 ]] && die "epatch_user takes no options"
425
426 # don't clobber any EPATCH vars that the parent might want
427 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
428 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
429 EPATCH_SOURCE=${base}/${CTARGET}/${check}
430 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
431 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
432 if [[ -d ${EPATCH_SOURCE} ]] ; then
433 EPATCH_SOURCE=${EPATCH_SOURCE} \
434 EPATCH_SUFFIX="patch" \
435 EPATCH_FORCE="yes" \
436 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
437 epatch
438 break
344 fi 439 fi
440 done
345} 441}
346 442
443# @FUNCTION: emktemp
444# @USAGE: [temp dir]
445# @DESCRIPTION:
347# Cheap replacement for when debianutils (and thus mktemp) 446# Cheap replacement for when debianutils (and thus mktemp)
348# does not exist on the users system 447# does not exist on the users system.
349# vapier@gentoo.org
350#
351# Takes just 1 optional parameter (the directory to create tmpfile in)
352emktemp() { 448emktemp() {
353 local exe="touch" 449 local exe="touch"
354 [[ $1 == -d ]] && exe="mkdir" && shift 450 [[ $1 == -d ]] && exe="mkdir" && shift
355 local topdir=$1 451 local topdir=$1
356 452
358 [[ -z ${T} ]] \ 454 [[ -z ${T} ]] \
359 && topdir="/tmp" \ 455 && topdir="/tmp" \
360 || topdir=${T} 456 || topdir=${T}
361 fi 457 fi
362 458
363 if [[ -z $(type -p mktemp) ]] ; then 459 if ! type -P mktemp > /dev/null ; then
460 # system lacks `mktemp` so we have to fake it
364 local tmp=/ 461 local tmp=/
365 while [[ -e ${tmp} ]] ; do 462 while [[ -e ${tmp} ]] ; do
366 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 463 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
367 done 464 done
368 ${exe} "${tmp}" || ${exe} -p "${tmp}" 465 ${exe} "${tmp}" || ${exe} -p "${tmp}"
369 echo "${tmp}" 466 echo "${tmp}"
370 else 467 else
468 # the args here will give slightly wierd names on BSD,
469 # but should produce a usable file on all userlands
371 if [[ ${exe} == "touch" ]] ; then 470 if [[ ${exe} == "touch" ]] ; then
372 [[ ${USERLAND} == "GNU" ]] \
373 && mktemp -p "${topdir}" \
374 || TMPDIR="${topdir}" mktemp -t tmp 471 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
375 else 472 else
376 [[ ${USERLAND} == "GNU" ]] \
377 && mktemp -d "${topdir}" \
378 || TMPDIR="${topdir}" mktemp -dt tmp 473 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
379 fi
380 fi 474 fi
475 fi
381} 476}
382 477
478# @FUNCTION: egetent
479# @USAGE: <database> <key>
480# @MAINTAINER:
481# base-system@gentoo.org (Linux)
482# Joe Jezak <josejx@gmail.com> (OS X)
483# usata@gentoo.org (OS X)
484# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
485# @DESCRIPTION:
383# Small wrapper for getent (Linux), nidump (Mac OS X), 486# Small wrapper for getent (Linux),
487# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
384# and pw (FreeBSD) used in enewuser()/enewgroup() 488# and pw (FreeBSD) used in enewuser()/enewgroup()
385# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
386# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
387#
388# egetent(database, key)
389egetent() { 489egetent() {
390 case ${CHOST} in 490 case ${CHOST} in
391 *-darwin*) 491 *-darwin[678])
392 case "$2" in 492 case "$2" in
393 *[!0-9]*) # Non numeric 493 *[!0-9]*) # Non numeric
394 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 494 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
395 ;; 495 ;;
396 *) # Numeric 496 *) # Numeric
397 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 497 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
498 ;;
499 esac
500 ;;
501 *-darwin*)
502 local mytype=$1
503 [[ "passwd" == $mytype ]] && mytype="Users"
504 [[ "group" == $mytype ]] && mytype="Groups"
505 case "$2" in
506 *[!0-9]*) # Non numeric
507 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
508 ;;
509 *) # Numeric
510 local mykey="UniqueID"
511 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
512 dscl . -search /$mytype $mykey $2 2>/dev/null
398 ;; 513 ;;
399 esac 514 esac
400 ;; 515 ;;
401 *-freebsd*|*-dragonfly*) 516 *-freebsd*|*-dragonfly*)
402 local opts action="user" 517 local opts action="user"
417 getent "$1" "$2" 532 getent "$1" "$2"
418 ;; 533 ;;
419 esac 534 esac
420} 535}
421 536
422# Simplify/standardize adding users to the system 537# @FUNCTION: enewuser
423# vapier@gentoo.org 538# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
424# 539# @DESCRIPTION:
425# enewuser(username, uid, shell, homedir, groups, extra options) 540# Same as enewgroup, you are not required to understand how to properly add
426# 541# a user to the system. The only required parameter is the username.
427# Default values if you do not specify any: 542# Default uid is (pass -1 for this) next available, default shell is
428# username: REQUIRED ! 543# /bin/false, default homedir is /dev/null, there are no default groups,
429# uid: next available (see useradd(8)) 544# and default params sets the comment as 'added by portage for ${PN}'.
430# note: pass -1 to get default behavior
431# shell: /bin/false
432# homedir: /dev/null
433# groups: none
434# extra: comment of 'added by portage for ${PN}'
435enewuser() { 545enewuser() {
436 case ${EBUILD_PHASE} in 546 case ${EBUILD_PHASE} in
437 unpack|compile|test|install) 547 unpack|compile|test|install)
438 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 548 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
439 eerror "Package fails at QA and at life. Please file a bug." 549 eerror "Package fails at QA and at life. Please file a bug."
446 eerror "No username specified !" 556 eerror "No username specified !"
447 die "Cannot call enewuser without a username" 557 die "Cannot call enewuser without a username"
448 fi 558 fi
449 559
450 # lets see if the username already exists 560 # lets see if the username already exists
451 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 561 if [[ -n $(egetent passwd "${euser}") ]] ; then
452 return 0 562 return 0
453 fi 563 fi
454 einfo "Adding user '${euser}' to your system ..." 564 einfo "Adding user '${euser}' to your system ..."
455 565
456 # options to pass to useradd 566 # options to pass to useradd
457 local opts= 567 local opts=
458 568
459 # handle uid 569 # handle uid
460 local euid=$1; shift 570 local euid=$1; shift
461 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 571 if [[ -n ${euid} && ${euid} != -1 ]] ; then
462 if [[ ${euid} -gt 0 ]] ; then 572 if [[ ${euid} -gt 0 ]] ; then
463 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 573 if [[ -n $(egetent passwd ${euid}) ]] ; then
464 euid="next" 574 euid="next"
465 fi 575 fi
466 else 576 else
467 eerror "Userid given but is not greater than 0 !" 577 eerror "Userid given but is not greater than 0 !"
468 die "${euid} is not a valid UID" 578 die "${euid} is not a valid UID"
469 fi 579 fi
470 else 580 else
471 euid="next" 581 euid="next"
472 fi 582 fi
473 if [[ ${euid} == "next" ]] ; then 583 if [[ ${euid} == "next" ]] ; then
474 for euid in $(seq 101 999) ; do 584 for ((euid = 101; euid <= 999; euid++)); do
475 [[ -z $(egetent passwd ${euid}) ]] && break 585 [[ -z $(egetent passwd ${euid}) ]] && break
476 done 586 done
477 fi 587 fi
478 opts="${opts} -u ${euid}" 588 opts="${opts} -u ${euid}"
479 einfo " - Userid: ${euid}" 589 einfo " - Userid: ${euid}"
493 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 603 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
494 [[ -x ${ROOT}${shell} ]] && break 604 [[ -x ${ROOT}${shell} ]] && break
495 done 605 done
496 606
497 if [[ ${shell} == "/dev/null" ]] ; then 607 if [[ ${shell} == "/dev/null" ]] ; then
498 eerror "Unable to identify the shell to use" 608 eerror "Unable to identify the shell to use, proceeding with userland default."
499 die "Unable to identify the shell to use" 609 case ${USERLAND} in
610 GNU) shell="/bin/false" ;;
611 BSD) shell="/sbin/nologin" ;;
612 Darwin) shell="/usr/sbin/nologin" ;;
613 *) die "Unable to identify the default shell for userland ${USERLAND}"
614 esac
500 fi 615 fi
501 616
502 eshell=${shell} 617 eshell=${shell}
503 fi 618 fi
504 einfo " - Shell: ${eshell}" 619 einfo " - Shell: ${eshell}"
602 fi 717 fi
603 ;; 718 ;;
604 719
605 *) 720 *)
606 if [[ -z $@ ]] ; then 721 if [[ -z $@ ]] ; then
607 useradd ${opts} ${euser} \ 722 useradd -r ${opts} \
608 -c "added by portage for ${PN}" \ 723 -c "added by portage for ${PN}" \
724 ${euser} \
609 || die "enewuser failed" 725 || die "enewuser failed"
610 else 726 else
611 einfo " - Extra: $@" 727 einfo " - Extra: $@"
612 useradd ${opts} ${euser} "$@" \ 728 useradd -r ${opts} "$@" \
729 ${euser} \
613 || die "enewuser failed" 730 || die "enewuser failed"
614 fi 731 fi
615 ;; 732 ;;
616 esac 733 esac
617 734
623 fi 740 fi
624 741
625 export SANDBOX_ON=${oldsandbox} 742 export SANDBOX_ON=${oldsandbox}
626} 743}
627 744
628# Simplify/standardize adding groups to the system 745# @FUNCTION: enewgroup
629# vapier@gentoo.org 746# @USAGE: <group> [gid]
630# 747# @DESCRIPTION:
631# enewgroup(group, gid) 748# This function does not require you to understand how to properly add a
632# 749# group to the system. Just give it a group name to add and enewgroup will
633# Default values if you do not specify any: 750# do the rest. You may specify the gid for the group or allow the group to
634# groupname: REQUIRED ! 751# allocate the next available one.
635# gid: next available (see groupadd(8))
636# extra: none
637enewgroup() { 752enewgroup() {
638 case ${EBUILD_PHASE} in 753 case ${EBUILD_PHASE} in
639 unpack|compile|test|install) 754 unpack|compile|test|install)
640 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 755 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
641 eerror "Package fails at QA and at life. Please file a bug." 756 eerror "Package fails at QA and at life. Please file a bug."
649 eerror "No group specified !" 764 eerror "No group specified !"
650 die "Cannot call enewgroup without a group" 765 die "Cannot call enewgroup without a group"
651 fi 766 fi
652 767
653 # see if group already exists 768 # see if group already exists
654 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 769 if [[ -n $(egetent group "${egroup}") ]]; then
655 then
656 return 0 770 return 0
657 fi 771 fi
658 einfo "Adding group '${egroup}' to your system ..." 772 einfo "Adding group '${egroup}' to your system ..."
659 773
660 # options to pass to useradd 774 # options to pass to useradd
703 fi 817 fi
704 818
705 # If we need the next available 819 # If we need the next available
706 case ${egid} in 820 case ${egid} in
707 *[!0-9]*) # Non numeric 821 *[!0-9]*) # Non numeric
708 for egid in $(seq 101 999); do 822 for ((egid = 101; egid <= 999; egid++)); do
709 [ -z "`egetent group ${egid}`" ] && break 823 [[ -z $(egetent group ${egid}) ]] && break
710 done 824 done
711 esac 825 esac
712 dscl . create /groups/${egroup} gid ${egid} 826 dscl . create /groups/${egroup} gid ${egid}
713 dscl . create /groups/${egroup} passwd '*' 827 dscl . create /groups/${egroup} passwd '*'
714 ;; 828 ;;
715 829
716 *-freebsd*|*-dragonfly*) 830 *-freebsd*|*-dragonfly*)
717 case ${egid} in 831 case ${egid} in
718 *[!0-9]*) # Non numeric 832 *[!0-9]*) # Non numeric
719 for egid in $(seq 101 999); do 833 for ((egid = 101; egid <= 999; egid++)); do
720 [ -z "`egetent group ${egid}`" ] && break 834 [[ -z $(egetent group ${egid}) ]] && break
721 done 835 done
722 esac 836 esac
723 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 837 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
724 ;; 838 ;;
725 839
726 *-netbsd*) 840 *-netbsd*)
727 case ${egid} in 841 case ${egid} in
728 *[!0-9]*) # Non numeric 842 *[!0-9]*) # Non numeric
729 for egid in $(seq 101 999); do 843 for ((egid = 101; egid <= 999; egid++)); do
730 [ -z "`egetent group ${egid}`" ] && break 844 [[ -z $(egetent group ${egid}) ]] && break
731 done 845 done
732 esac 846 esac
733 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 847 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
734 ;; 848 ;;
735 849
736 *) 850 *)
851 # We specify -r so that we get a GID in the system range from login.defs
737 groupadd ${opts} ${egroup} || die "enewgroup failed" 852 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
738 ;; 853 ;;
739 esac 854 esac
740 export SANDBOX_ON="${oldsandbox}" 855 export SANDBOX_ON="${oldsandbox}"
741} 856}
742 857
743# Simple script to replace 'dos2unix' binaries 858# @FUNCTION: edos2unix
744# vapier@gentoo.org 859# @USAGE: <file> [more files ...]
745# 860# @DESCRIPTION:
746# edos2unix(file, <more files> ...) 861# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
862# to remove all of these text utilities from DEPEND variables because this
863# is a script based solution. Just give it a list of files to convert and
864# they will all be changed from the DOS CRLF format to the UNIX LF format.
747edos2unix() { 865edos2unix() {
748 for f in "$@" 866 echo "$@" | xargs sed -i 's/\r$//'
749 do
750 cp "${f}" ${T}/edos2unix
751 sed 's/\r$//' ${T}/edos2unix > "${f}"
752 done
753} 867}
754
755
756##############################################################
757# START: Handle .desktop files and menu entries #
758# maybe this should be separated into a new eclass some time #
759# lanius@gentoo.org #
760##############################################################
761 868
762# Make a desktop file ! 869# Make a desktop file !
763# Great for making those icons in kde/gnome startmenu ! 870# Great for making those icons in kde/gnome startmenu !
764# Amaze your friends ! Get the women ! Join today ! 871# Amaze your friends ! Get the women ! Join today !
765# 872#
766# make_desktop_entry(<command>, [name], [icon], [type], [path]) 873# make_desktop_entry(<command>, [name], [icon], [type], [fields])
767# 874#
768# binary: what command does the app run with ? 875# binary: what command does the app run with ?
769# name: the name that will show up in the menu 876# name: the name that will show up in the menu
770# icon: give your little like a pretty little icon ... 877# icon: give your little like a pretty little icon ...
771# this can be relative (to /usr/share/pixmaps) or 878# this can be relative (to /usr/share/pixmaps) or
772# a full path to an icon 879# a full path to an icon
773# type: what kind of application is this ? for categories: 880# type: what kind of application is this ? for categories:
774# http://www.freedesktop.org/Standards/desktop-entry-spec 881# http://standards.freedesktop.org/menu-spec/latest/apa.html
775# path: if your app needs to startup in a specific dir 882# fields: extra fields to append to the desktop file; a printf string
776make_desktop_entry() { 883make_desktop_entry() {
777 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 884 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
778 885
779 local exec=${1} 886 local exec=${1}
780 local name=${2:-${PN}} 887 local name=${2:-${PN}}
781 local icon=${3:-${PN}.png} 888 local icon=${3:-${PN}}
782 local type=${4} 889 local type=${4}
783 local path=${5} 890 local fields=${5}
784 891
785 if [[ -z ${type} ]] ; then 892 if [[ -z ${type} ]] ; then
786 local catmaj=${CATEGORY%%-*} 893 local catmaj=${CATEGORY%%-*}
787 local catmin=${CATEGORY##*-} 894 local catmin=${CATEGORY##*-}
788 case ${catmaj} in 895 case ${catmaj} in
789 app) 896 app)
790 case ${catmin} in 897 case ${catmin} in
898 accessibility) type=Accessibility;;
791 admin) type=System;; 899 admin) type=System;;
900 antivirus) type=System;;
901 arch) type=Archiving;;
902 backup) type=Archiving;;
792 cdr) type=DiscBurning;; 903 cdr) type=DiscBurning;;
793 dicts) type=Dictionary;; 904 dicts) type=Dictionary;;
905 doc) type=Documentation;;
794 editors) type=TextEditor;; 906 editors) type=TextEditor;;
795 emacs) type=TextEditor;; 907 emacs) type=TextEditor;;
796 emulation) type=Emulator;; 908 emulation) type=Emulator;;
797 laptop) type=HardwareSettings;; 909 laptop) type=HardwareSettings;;
798 office) type=Office;; 910 office) type=Office;;
911 pda) type=PDA;;
799 vim) type=TextEditor;; 912 vim) type=TextEditor;;
800 xemacs) type=TextEditor;; 913 xemacs) type=TextEditor;;
801 *) type=;;
802 esac 914 esac
803 ;; 915 ;;
804 916
805 dev) 917 dev)
806 type="Development" 918 type="Development"
807 ;; 919 ;;
808 920
809 games) 921 games)
810 case ${catmin} in 922 case ${catmin} in
811 action) type=ActionGame;; 923 action|fps) type=ActionGame;;
812 arcade) type=ArcadeGame;; 924 arcade) type=ArcadeGame;;
813 board) type=BoardGame;; 925 board) type=BoardGame;;
814 kid) type=KidsGame;;
815 emulation) type=Emulator;; 926 emulation) type=Emulator;;
927 kids) type=KidsGame;;
816 puzzle) type=LogicGame;; 928 puzzle) type=LogicGame;;
929 roguelike) type=RolePlaying;;
817 rpg) type=RolePlaying;; 930 rpg) type=RolePlaying;;
818 roguelike) type=RolePlaying;;
819 simulation) type=Simulation;; 931 simulation) type=Simulation;;
820 sports) type=SportsGame;; 932 sports) type=SportsGame;;
821 strategy) type=StrategyGame;; 933 strategy) type=StrategyGame;;
822 *) type=;;
823 esac 934 esac
824 type="Game;${type}" 935 type="Game;${type}"
825 ;; 936 ;;
826 937
938 gnome)
939 type="Gnome;GTK"
940 ;;
941
942 kde)
943 type="KDE;Qt"
944 ;;
945
827 mail) 946 mail)
828 type="Network;Email" 947 type="Network;Email"
829 ;; 948 ;;
830 949
831 media) 950 media)
832 case ${catmin} in 951 case ${catmin} in
952 gfx)
833 gfx) type=Graphics;; 953 type=Graphics
954 ;;
955 *)
956 case ${catmin} in
834 radio) type=Tuner;; 957 radio) type=Tuner;;
835 sound) type=Audio;; 958 sound) type=Audio;;
836 tv) type=TV;; 959 tv) type=TV;;
837 video) type=Video;; 960 video) type=Video;;
838 *) type=;; 961 esac
962 type="AudioVideo;${type}"
963 ;;
839 esac 964 esac
840 type="AudioVideo;${type}"
841 ;; 965 ;;
842 966
843 net) 967 net)
844 case ${catmin} in 968 case ${catmin} in
845 dialup) type=Dialup;; 969 dialup) type=Dialup;;
848 irc) type=IRCClient;; 972 irc) type=IRCClient;;
849 mail) type=Email;; 973 mail) type=Email;;
850 news) type=News;; 974 news) type=News;;
851 nntp) type=News;; 975 nntp) type=News;;
852 p2p) type=FileTransfer;; 976 p2p) type=FileTransfer;;
853 *) type=;; 977 voip) type=Telephony;;
854 esac 978 esac
855 type="Network;${type}" 979 type="Network;${type}"
856 ;; 980 ;;
857 981
858 sci) 982 sci)
859 case ${catmin} in 983 case ${catmin} in
860 astro*) type=Astronomy;; 984 astro*) type=Astronomy;;
861 bio*) type=Biology;; 985 bio*) type=Biology;;
862 calc*) type=Calculator;; 986 calc*) type=Calculator;;
863 chem*) type=Chemistry;; 987 chem*) type=Chemistry;;
988 elec*) type=Electronics;;
864 geo*) type=Geology;; 989 geo*) type=Geology;;
865 math*) type=Math;; 990 math*) type=Math;;
866 *) type=;; 991 physics) type=Physics;;
992 visual*) type=DataVisualization;;
867 esac 993 esac
868 type="Science;${type}" 994 type="Education;Science;${type}"
995 ;;
996
997 sys)
998 type="System"
869 ;; 999 ;;
870 1000
871 www) 1001 www)
872 case ${catmin} in 1002 case ${catmin} in
873 client) type=WebBrowser;; 1003 client) type=WebBrowser;;
874 *) type=;;
875 esac 1004 esac
876 type="Network" 1005 type="Network;${type}"
877 ;; 1006 ;;
878 1007
879 *) 1008 *)
880 type= 1009 type=
881 ;; 1010 ;;
884 if [ "${SLOT}" == "0" ] ; then 1013 if [ "${SLOT}" == "0" ] ; then
885 local desktop_name="${PN}" 1014 local desktop_name="${PN}"
886 else 1015 else
887 local desktop_name="${PN}-${SLOT}" 1016 local desktop_name="${PN}-${SLOT}"
888 fi 1017 fi
889 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1018 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
890# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1019 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
891 1020
1021 # Don't append another ";" when a valid category value is provided.
1022 type=${type%;}${type:+;}
1023
1024 eshopts_push -s extglob
1025 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1026 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1027 ewarn "allowed in .desktop files if the value is not an absolute path."
1028 icon=${icon%.@(xpm|png|svg)}
1029 fi
1030 eshopts_pop
1031
1032 cat <<-EOF > "${desktop}"
892echo "[Desktop Entry] 1033 [Desktop Entry]
893Encoding=UTF-8
894Version=0.9.2
895Name=${name} 1034 Name=${name}
896Type=Application 1035 Type=Application
897Comment=${DESCRIPTION} 1036 Comment=${DESCRIPTION}
898Exec=${exec} 1037 Exec=${exec}
899TryExec=${exec%% *} 1038 TryExec=${exec%% *}
900Path=${path}
901Icon=${icon} 1039 Icon=${icon}
902Categories=Application;${type};" > "${desktop}" 1040 Categories=${type}
1041 EOF
1042
1043 if [[ ${fields:-=} != *=* ]] ; then
1044 # 5th arg used to be value to Path=
1045 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1046 fields="Path=${fields}"
1047 fi
1048 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
903 1049
904 ( 1050 (
905 # wrap the env here so that the 'insinto' call 1051 # wrap the env here so that the 'insinto' call
906 # doesn't corrupt the env of the caller 1052 # doesn't corrupt the env of the caller
907 insinto /usr/share/applications 1053 insinto /usr/share/applications
908 doins "${desktop}" 1054 doins "${desktop}"
909 ) 1055 ) || die "installing desktop file failed"
910} 1056}
911 1057
912# Make a GDM/KDM Session file 1058# @FUNCTION: validate_desktop_entries
913# 1059# @USAGE: [directories]
914# make_desktop_entry(<title>, <command>) 1060# @MAINTAINER:
915# title: File to execute to start the Window Manager 1061# Carsten Lohrke <carlo@gentoo.org>
916# command: Name of the Window Manager 1062# @DESCRIPTION:
1063# Validate desktop entries using desktop-file-utils
1064validate_desktop_entries() {
1065 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1066 einfo "Checking desktop entry validity"
1067 local directories=""
1068 for d in /usr/share/applications $@ ; do
1069 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1070 done
1071 if [[ -n ${directories} ]] ; then
1072 for FILE in $(find ${directories} -name "*\.desktop" \
1073 -not -path '*.hidden*' | sort -u 2>/dev/null)
1074 do
1075 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1076 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1077 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1078 done
1079 fi
1080 echo ""
1081 else
1082 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1083 fi
1084}
917 1085
1086# @FUNCTION: make_session_desktop
1087# @USAGE: <title> <command> [command args...]
1088# @DESCRIPTION:
1089# Make a GDM/KDM Session file. The title is the file to execute to start the
1090# Window Manager. The command is the name of the Window Manager.
1091#
1092# You can set the name of the file via the ${wm} variable.
918make_session_desktop() { 1093make_session_desktop() {
919 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1094 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
920 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1095 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
921 1096
922 local title=$1 1097 local title=$1
923 local command=$2 1098 local command=$2
924 local desktop=${T}/${wm}.desktop 1099 local desktop=${T}/${wm:-${PN}}.desktop
1100 shift 2
925 1101
1102 cat <<-EOF > "${desktop}"
926echo "[Desktop Entry] 1103 [Desktop Entry]
927Encoding=UTF-8
928Name=${title} 1104 Name=${title}
929Comment=This session logs you into ${title} 1105 Comment=This session logs you into ${title}
930Exec=${command} 1106 Exec=${command} $*
931TryExec=${command} 1107 TryExec=${command}
932Type=Application" > "${desktop}" 1108 Type=XSession
1109 EOF
933 1110
1111 (
1112 # wrap the env here so that the 'insinto' call
1113 # doesn't corrupt the env of the caller
934 insinto /usr/share/xsessions 1114 insinto /usr/share/xsessions
935 doins "${desktop}" 1115 doins "${desktop}"
1116 )
936} 1117}
937 1118
1119# @FUNCTION: domenu
1120# @USAGE: <menus>
1121# @DESCRIPTION:
1122# Install the list of .desktop menu files into the appropriate directory
1123# (/usr/share/applications).
938domenu() { 1124domenu() {
1125 (
1126 # wrap the env here so that the 'insinto' call
1127 # doesn't corrupt the env of the caller
939 local i j 1128 local i j ret=0
940 insinto /usr/share/applications 1129 insinto /usr/share/applications
941 for i in "$@" ; do 1130 for i in "$@" ; do
942 if [[ -f ${i} ]] ; then 1131 if [[ -f ${i} ]] ; then
943 doins "${i}" 1132 doins "${i}"
1133 ((ret+=$?))
944 elif [[ -d ${i} ]] ; then 1134 elif [[ -d ${i} ]] ; then
945 for j in "${i}"/*.desktop ; do 1135 for j in "${i}"/*.desktop ; do
946 doins "${j}" 1136 doins "${j}"
1137 ((ret+=$?))
947 done 1138 done
1139 else
1140 ((++ret))
948 fi 1141 fi
949 done 1142 done
1143 exit ${ret}
1144 )
950} 1145}
1146
1147# @FUNCTION: newmenu
1148# @USAGE: <menu> <newname>
1149# @DESCRIPTION:
1150# Like all other new* functions, install the specified menu as newname.
951newmenu() { 1151newmenu() {
1152 (
1153 # wrap the env here so that the 'insinto' call
1154 # doesn't corrupt the env of the caller
952 insinto /usr/share/applications 1155 insinto /usr/share/applications
953 newins "$1" "$2" 1156 newins "$@"
1157 )
954} 1158}
955 1159
1160# @FUNCTION: doicon
1161# @USAGE: <list of icons>
1162# @DESCRIPTION:
1163# Install the list of icons into the icon directory (/usr/share/pixmaps).
1164# This is useful in conjunction with creating desktop/menu files.
956doicon() { 1165doicon() {
1166 (
1167 # wrap the env here so that the 'insinto' call
1168 # doesn't corrupt the env of the caller
957 local i j 1169 local i j ret
958 insinto /usr/share/pixmaps 1170 insinto /usr/share/pixmaps
959 for i in "$@" ; do 1171 for i in "$@" ; do
960 if [[ -f ${i} ]] ; then 1172 if [[ -f ${i} ]] ; then
961 doins "${i}" 1173 doins "${i}"
1174 ((ret+=$?))
962 elif [[ -d ${i} ]] ; then 1175 elif [[ -d ${i} ]] ; then
963 for j in "${i}"/*.png ; do 1176 for j in "${i}"/*.png ; do
964 doins "${j}" 1177 doins "${j}"
1178 ((ret+=$?))
965 done 1179 done
1180 else
1181 ((++ret))
966 fi 1182 fi
967 done 1183 done
1184 exit ${ret}
1185 )
968} 1186}
1187
1188# @FUNCTION: newicon
1189# @USAGE: <icon> <newname>
1190# @DESCRIPTION:
1191# Like all other new* functions, install the specified icon as newname.
969newicon() { 1192newicon() {
1193 (
1194 # wrap the env here so that the 'insinto' call
1195 # doesn't corrupt the env of the caller
970 insinto /usr/share/pixmaps 1196 insinto /usr/share/pixmaps
971 newins "$1" "$2" 1197 newins "$@"
1198 )
972} 1199}
973
974##############################################################
975# END: Handle .desktop files and menu entries #
976##############################################################
977
978 1200
979# for internal use only (unpack_pdv and unpack_makeself) 1201# for internal use only (unpack_pdv and unpack_makeself)
980find_unpackable_file() { 1202find_unpackable_file() {
981 local src=$1 1203 local src=$1
982 if [[ -z ${src} ]] ; then 1204 if [[ -z ${src} ]] ; then
992 fi 1214 fi
993 [[ ! -e ${src} ]] && return 1 1215 [[ ! -e ${src} ]] && return 1
994 echo "${src}" 1216 echo "${src}"
995} 1217}
996 1218
1219# @FUNCTION: unpack_pdv
1220# @USAGE: <file to unpack> <size of off_t>
1221# @DESCRIPTION:
997# Unpack those pesky pdv generated files ... 1222# Unpack those pesky pdv generated files ...
998# They're self-unpacking programs with the binary package stuffed in 1223# They're self-unpacking programs with the binary package stuffed in
999# the middle of the archive. Valve seems to use it a lot ... too bad 1224# the middle of the archive. Valve seems to use it a lot ... too bad
1000# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1225# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1001# 1226#
1002# Usage: unpack_pdv [file to unpack] [size of off_t]
1003# - you have to specify the off_t size ... i have no idea how to extract that 1227# You have to specify the off_t size ... I have no idea how to extract that
1004# information out of the binary executable myself. basically you pass in 1228# information out of the binary executable myself. Basically you pass in
1005# the size of the off_t type (in bytes) on the machine that built the pdv 1229# the size of the off_t type (in bytes) on the machine that built the pdv
1230# archive.
1231#
1006# archive. one way to determine this is by running the following commands: 1232# One way to determine this is by running the following commands:
1233#
1234# @CODE
1007# strings <pdv archive> | grep lseek 1235# strings <pdv archive> | grep lseek
1008# strace -elseek <pdv archive> 1236# strace -elseek <pdv archive>
1237# @CODE
1238#
1009# basically look for the first lseek command (we do the strings/grep because 1239# Basically look for the first lseek command (we do the strings/grep because
1010# sometimes the function call is _llseek or something) and steal the 2nd 1240# sometimes the function call is _llseek or something) and steal the 2nd
1011# parameter. here is an example: 1241# parameter. Here is an example:
1242#
1243# @CODE
1012# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1244# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1013# lseek 1245# lseek
1014# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1246# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1015# lseek(3, -4, SEEK_END) = 2981250 1247# lseek(3, -4, SEEK_END) = 2981250
1248# @CODE
1249#
1016# thus we would pass in the value of '4' as the second parameter. 1250# Thus we would pass in the value of '4' as the second parameter.
1017unpack_pdv() { 1251unpack_pdv() {
1018 local src=$(find_unpackable_file $1) 1252 local src=$(find_unpackable_file "$1")
1019 local sizeoff_t=$2 1253 local sizeoff_t=$2
1020 1254
1021 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1255 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1022 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1256 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1023 1257
1024 local shrtsrc=$(basename "${src}") 1258 local shrtsrc=$(basename "${src}")
1025 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1259 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1026 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1260 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1027 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1261 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1028 1262
1029 # grab metadata for debug reasons 1263 # grab metadata for debug reasons
1030 local metafile="$(emktemp)" 1264 local metafile=$(emktemp)
1031 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1265 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1032 1266
1033 # rip out the final file name from the metadata 1267 # rip out the final file name from the metadata
1034 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1268 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1035 datafile="`basename ${datafile}`" 1269 datafile=$(basename "${datafile}")
1036 1270
1037 # now lets uncompress/untar the file if need be 1271 # now lets uncompress/untar the file if need be
1038 local tmpfile="$(emktemp)" 1272 local tmpfile=$(emktemp)
1039 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1273 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1040 1274
1041 local iscompressed="`file -b ${tmpfile}`" 1275 local iscompressed=$(file -b "${tmpfile}")
1042 if [ "${iscompressed:0:8}" == "compress" ] ; then 1276 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1043 iscompressed=1 1277 iscompressed=1
1044 mv ${tmpfile}{,.Z} 1278 mv ${tmpfile}{,.Z}
1045 gunzip ${tmpfile} 1279 gunzip ${tmpfile}
1046 else 1280 else
1047 iscompressed=0 1281 iscompressed=0
1048 fi 1282 fi
1049 local istar="`file -b ${tmpfile}`" 1283 local istar=$(file -b "${tmpfile}")
1050 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1284 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1051 istar=1 1285 istar=1
1052 else 1286 else
1053 istar=0 1287 istar=0
1054 fi 1288 fi
1055 1289
1083 true 1317 true
1084 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1318 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1085 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1319 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1086} 1320}
1087 1321
1322# @FUNCTION: unpack_makeself
1323# @USAGE: [file to unpack] [offset] [tail|dd]
1324# @DESCRIPTION:
1088# Unpack those pesky makeself generated files ... 1325# Unpack those pesky makeself generated files ...
1089# They're shell scripts with the binary package tagged onto 1326# They're shell scripts with the binary package tagged onto
1090# the end of the archive. Loki utilized the format as does 1327# the end of the archive. Loki utilized the format as does
1091# many other game companies. 1328# many other game companies.
1092# 1329#
1093# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1330# If the file is not specified, then ${A} is used. If the
1094# - If the file is not specified then unpack will utilize ${A}.
1095# - If the offset is not specified then we will attempt to extract 1331# offset is not specified then we will attempt to extract
1096# the proper offset from the script itself. 1332# the proper offset from the script itself.
1097unpack_makeself() { 1333unpack_makeself() {
1098 local src_input=${1:-${A}} 1334 local src_input=${1:-${A}}
1099 local src=$(find_unpackable_file "${src_input}") 1335 local src=$(find_unpackable_file "${src_input}")
1100 local skip=$2 1336 local skip=$2
1101 local exe=$3 1337 local exe=$3
1103 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1339 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1104 1340
1105 local shrtsrc=$(basename "${src}") 1341 local shrtsrc=$(basename "${src}")
1106 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1342 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1107 if [[ -z ${skip} ]] ; then 1343 if [[ -z ${skip} ]] ; then
1108 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1344 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1109 local skip=0 1345 local skip=0
1110 exe=tail 1346 exe=tail
1111 case ${ver} in 1347 case ${ver} in
1112 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1348 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1113 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1349 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1115 2.0|2.0.1) 1351 2.0|2.0.1)
1116 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1352 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1117 ;; 1353 ;;
1118 2.1.1) 1354 2.1.1)
1119 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1355 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1120 let skip="skip + 1" 1356 (( skip++ ))
1121 ;; 1357 ;;
1122 2.1.2) 1358 2.1.2)
1123 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1359 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1124 let skip="skip + 1" 1360 (( skip++ ))
1125 ;; 1361 ;;
1126 2.1.3) 1362 2.1.3)
1127 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1363 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1128 let skip="skip + 1" 1364 (( skip++ ))
1129 ;; 1365 ;;
1130 2.1.4|2.1.5) 1366 2.1.4|2.1.5)
1131 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1367 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1132 skip=$(head -n ${skip} "${src}" | wc -c) 1368 skip=$(head -n ${skip} "${src}" | wc -c)
1133 exe="dd" 1369 exe="dd"
1142 esac 1378 esac
1143 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1379 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1144 fi 1380 fi
1145 case ${exe} in 1381 case ${exe} in
1146 tail) exe="tail -n +${skip} '${src}'";; 1382 tail) exe="tail -n +${skip} '${src}'";;
1147 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1383 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1148 *) die "makeself cant handle exe '${exe}'" 1384 *) die "makeself cant handle exe '${exe}'"
1149 esac 1385 esac
1150 1386
1151 # lets grab the first few bytes of the file to figure out what kind of archive it is 1387 # lets grab the first few bytes of the file to figure out what kind of archive it is
1152 local tmpfile="$(emktemp)" 1388 local tmpfile=$(emktemp)
1153 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1389 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1154 local filetype="$(file -b "${tmpfile}")" 1390 local filetype=$(file -b "${tmpfile}")
1155 case ${filetype} in 1391 case ${filetype} in
1156 *tar\ archive) 1392 *tar\ archive*)
1157 eval ${exe} | tar --no-same-owner -xf - 1393 eval ${exe} | tar --no-same-owner -xf -
1158 ;; 1394 ;;
1159 bzip2*) 1395 bzip2*)
1160 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1396 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1161 ;; 1397 ;;
1171 ;; 1407 ;;
1172 esac 1408 esac
1173 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1409 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1174} 1410}
1175 1411
1412# @FUNCTION: check_license
1413# @USAGE: [license]
1414# @DESCRIPTION:
1176# Display a license for user to accept. 1415# Display a license for user to accept. If no license is
1177#
1178# Usage: check_license [license]
1179# - If the file is not specified then ${LICENSE} is used. 1416# specified, then ${LICENSE} is used.
1180check_license() { 1417check_license() {
1181 local lic=$1 1418 local lic=$1
1182 if [ -z "${lic}" ] ; then 1419 if [ -z "${lic}" ] ; then
1183 lic="${PORTDIR}/licenses/${LICENSE}" 1420 lic="${PORTDIR}/licenses/${LICENSE}"
1184 else 1421 else
1188 lic="${PWD}/${lic}" 1425 lic="${PWD}/${lic}"
1189 elif [ -e "${lic}" ] ; then 1426 elif [ -e "${lic}" ] ; then
1190 lic="${lic}" 1427 lic="${lic}"
1191 fi 1428 fi
1192 fi 1429 fi
1193 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1194 local l="`basename ${lic}`" 1430 local l="`basename ${lic}`"
1195 1431
1196 # here is where we check for the licenses the user already 1432 # here is where we check for the licenses the user already
1197 # accepted ... if we don't find a match, we make the user accept 1433 # accepted ... if we don't find a match, we make the user accept
1198 local shopts=$-
1199 local alic 1434 local alic
1200 set -o noglob #so that bash doesn't expand "*" 1435 eshopts_push -o noglob # so that bash doesn't expand "*"
1201 for alic in ${ACCEPT_LICENSE} ; do 1436 for alic in ${ACCEPT_LICENSE} ; do
1202 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1437 if [[ ${alic} == ${l} ]]; then
1203 set +o noglob; set -${shopts} #reset old shell opts 1438 eshopts_pop
1204 return 0 1439 return 0
1205 fi 1440 fi
1206 done 1441 done
1207 set +o noglob; set -$shopts #reset old shell opts 1442 eshopts_pop
1443 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1208 1444
1209 local licmsg="$(emktemp)" 1445 local licmsg=$(emktemp)
1210 cat << EOF > ${licmsg} 1446 cat <<-EOF > ${licmsg}
1211********************************************************** 1447 **********************************************************
1212The following license outlines the terms of use of this 1448 The following license outlines the terms of use of this
1213package. You MUST accept this license for installation to 1449 package. You MUST accept this license for installation to
1214continue. When you are done viewing, hit 'q'. If you 1450 continue. When you are done viewing, hit 'q'. If you
1215CTRL+C out of this, the install will not run! 1451 CTRL+C out of this, the install will not run!
1216********************************************************** 1452 **********************************************************
1217 1453
1218EOF 1454 EOF
1219 cat ${lic} >> ${licmsg} 1455 cat ${lic} >> ${licmsg}
1220 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1456 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1221 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1457 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1222 read alic 1458 read alic
1223 case ${alic} in 1459 case ${alic} in
1230 die "Failed to accept license" 1466 die "Failed to accept license"
1231 ;; 1467 ;;
1232 esac 1468 esac
1233} 1469}
1234 1470
1471# @FUNCTION: cdrom_get_cds
1472# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1473# @DESCRIPTION:
1235# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1474# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1236# the whole 'non-interactive' policy, but damnit I want CD support ! 1475# the whole 'non-interactive' policy, but damnit I want CD support !
1237# 1476#
1238# with these cdrom functions we handle all the user interaction and 1477# With these cdrom functions we handle all the user interaction and
1239# standardize everything. all you have to do is call cdrom_get_cds() 1478# standardize everything. All you have to do is call cdrom_get_cds()
1240# and when the function returns, you can assume that the cd has been 1479# and when the function returns, you can assume that the cd has been
1241# found at CDROM_ROOT. 1480# found at CDROM_ROOT.
1242# 1481#
1482# The function will attempt to locate a cd based upon a file that is on
1483# the cd. The more files you give this function, the more cds
1484# the cdrom functions will handle.
1485#
1243# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1486# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1244# etc... if you want to give the cds better names, then just export 1487# etc... If you want to give the cds better names, then just export
1245# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1488# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1246# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1489# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1247# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1490# also use the CDROM_NAME_SET bash array.
1248# CDROM_NAME_2="data cd"
1249# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1250# 1491#
1251# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1492# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1252#
1253# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1254# - this will attempt to locate a cd based upon a file that is on
1255# the cd ... the more files you give this function, the more cds
1256# the cdrom functions will handle
1257cdrom_get_cds() { 1493cdrom_get_cds() {
1258 # first we figure out how many cds we're dealing with by 1494 # first we figure out how many cds we're dealing with by
1259 # the # of files they gave us 1495 # the # of files they gave us
1260 local cdcnt=0 1496 local cdcnt=0
1261 local f= 1497 local f=
1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1521 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1522 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1 1523 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do 1524 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET)) 1525 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break 1526 [[ -e ${CDROM_ROOT}/${f} ]] && break
1291 done 1527 done
1292 export CDROM_MATCH=${f} 1528 export CDROM_MATCH=${f}
1293 return 1529 return
1294 fi 1530 fi
1295 1531
1347 export CDROM_SET="" 1583 export CDROM_SET=""
1348 export CDROM_CURRENT_CD=0 1584 export CDROM_CURRENT_CD=0
1349 cdrom_load_next_cd 1585 cdrom_load_next_cd
1350} 1586}
1351 1587
1352# this is only used when you need access to more than one cd. 1588# @FUNCTION: cdrom_load_next_cd
1353# when you have finished using the first cd, just call this function. 1589# @DESCRIPTION:
1354# when it returns, CDROM_ROOT will be pointing to the second cd. 1590# Some packages are so big they come on multiple CDs. When you're done reading
1355# remember, you can only go forward in the cd chain, you can't go back. 1591# files off a CD and want access to the next one, just call this function.
1592# Again, all the messy details of user interaction are taken care of for you.
1593# Once this returns, just read the variable CDROM_ROOT for the location of the
1594# mounted CD. Note that you can only go forward in the CD list, so make sure
1595# you only call this function when you're done using the current CD.
1356cdrom_load_next_cd() { 1596cdrom_load_next_cd() {
1357 local var 1597 local var
1358 ((++CDROM_CURRENT_CD)) 1598 ((++CDROM_CURRENT_CD))
1359 1599
1360 unset CDROM_ROOT 1600 unset CDROM_ROOT
1377# displayed and we'll hang out here until: 1617# displayed and we'll hang out here until:
1378# (1) the file is found on a mounted cdrom 1618# (1) the file is found on a mounted cdrom
1379# (2) the user hits CTRL+C 1619# (2) the user hits CTRL+C
1380_cdrom_locate_file_on_cd() { 1620_cdrom_locate_file_on_cd() {
1381 local mline="" 1621 local mline=""
1382 local showedmsg=0 1622 local showedmsg=0 showjolietmsg=0
1383 1623
1384 while [[ -z ${CDROM_ROOT} ]] ; do 1624 while [[ -z ${CDROM_ROOT} ]] ; do
1385 local i=0 1625 local i=0
1386 local -a cdset=(${*//:/ }) 1626 local -a cdset=(${*//:/ })
1387 if [[ -n ${CDROM_SET} ]] ; then 1627 if [[ -n ${CDROM_SET} ]] ; then
1390 1630
1391 while [[ -n ${cdset[${i}]} ]] ; do 1631 while [[ -n ${cdset[${i}]} ]] ; do
1392 local dir=$(dirname ${cdset[${i}]}) 1632 local dir=$(dirname ${cdset[${i}]})
1393 local file=$(basename ${cdset[${i}]}) 1633 local file=$(basename ${cdset[${i}]})
1394 1634
1395 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1635 local point= node= fs= foo=
1636 while read point node fs foo ; do
1637 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1638 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1639 && continue
1640 point=${point//\040/ }
1396 [[ -d ${mline}/${dir} ]] || continue 1641 [[ ! -d ${point}/${dir} ]] && continue
1397 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1642 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1398 export CDROM_ROOT=${mline} 1643 export CDROM_ROOT=${point}
1399 export CDROM_SET=${i} 1644 export CDROM_SET=${i}
1400 export CDROM_MATCH=${cdset[${i}]} 1645 export CDROM_MATCH=${cdset[${i}]}
1401 return 1646 return
1402 fi 1647 done <<< "$(get_mounts)"
1403 done
1404 1648
1405 ((++i)) 1649 ((++i))
1406 done 1650 done
1407 1651
1408 echo 1652 echo
1424 showedmsg=1 1668 showedmsg=1
1425 fi 1669 fi
1426 einfo "Press return to scan for the cd again" 1670 einfo "Press return to scan for the cd again"
1427 einfo "or hit CTRL+C to abort the emerge." 1671 einfo "or hit CTRL+C to abort the emerge."
1428 echo 1672 echo
1673 if [[ ${showjolietmsg} -eq 0 ]] ; then
1674 showjolietmsg=1
1675 else
1429 einfo "If you are having trouble with the detection" 1676 ewarn "If you are having trouble with the detection"
1430 einfo "of your CD, it is possible that you do not have" 1677 ewarn "of your CD, it is possible that you do not have"
1431 einfo "Joliet support enabled in your kernel. Please" 1678 ewarn "Joliet support enabled in your kernel. Please"
1432 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1679 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1680 ebeep 5
1681 fi
1433 read || die "something is screwed with your system" 1682 read || die "something is screwed with your system"
1434 done 1683 done
1435} 1684}
1436 1685
1686# @FUNCTION: strip-linguas
1687# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1688# @DESCRIPTION:
1437# Make sure that LINGUAS only contains languages that 1689# Make sure that LINGUAS only contains languages that
1438# a package can support 1690# a package can support. The first form allows you to
1439# 1691# specify a list of LINGUAS. The -i builds a list of po
1440# usage: strip-linguas <allow LINGUAS> 1692# files found in all the directories and uses the
1441# strip-linguas -i <directories of .po files> 1693# intersection of the lists. The -u builds a list of po
1442# strip-linguas -u <directories of .po files> 1694# files found in all the directories and uses the union
1443# 1695# of the lists.
1444# The first form allows you to specify a list of LINGUAS.
1445# The -i builds a list of po files found in all the
1446# directories and uses the intersection of the lists.
1447# The -u builds a list of po files found in all the
1448# directories and uses the union of the lists.
1449strip-linguas() { 1696strip-linguas() {
1450 local ls newls nols 1697 local ls newls nols
1451 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1698 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1452 local op=$1; shift 1699 local op=$1; shift
1453 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1700 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1454 local d f 1701 local d f
1455 for d in "$@" ; do 1702 for d in "$@" ; do
1456 if [[ ${op} == "-u" ]] ; then 1703 if [[ ${op} == "-u" ]] ; then
1457 newls=${ls} 1704 newls=${ls}
1458 else 1705 else
1459 newls="" 1706 newls=""
1460 fi 1707 fi
1461 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1708 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1462 if [[ ${op} == "-i" ]] ; then 1709 if [[ ${op} == "-i" ]] ; then
1463 hasq ${f} ${ls} && newls="${newls} ${f}" 1710 hasq ${f} ${ls} && newls="${newls} ${f}"
1464 else 1711 else
1465 hasq ${f} ${ls} || newls="${newls} ${f}" 1712 hasq ${f} ${ls} || newls="${newls} ${f}"
1466 fi 1713 fi
1479 else 1726 else
1480 nols="${nols} ${f}" 1727 nols="${nols} ${f}"
1481 fi 1728 fi
1482 done 1729 done
1483 [[ -n ${nols} ]] \ 1730 [[ -n ${nols} ]] \
1484 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1731 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1485 export LINGUAS=${newls:1} 1732 export LINGUAS=${newls:1}
1486} 1733}
1487 1734
1488# moved from kernel.eclass since they are generally useful outside of 1735# @FUNCTION: preserve_old_lib
1489# kernel.eclass -iggy (20041002) 1736# @USAGE: <libs to preserve> [more libs]
1490 1737# @DESCRIPTION:
1491# the following functions are useful in kernel module ebuilds, etc.
1492# for an example see ivtv or drbd ebuilds
1493
1494# set's ARCH to match what the kernel expects
1495set_arch_to_kernel() {
1496 i=10
1497 while ((i--)) ; do
1498 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1499 done
1500 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1501 case ${ARCH} in
1502 x86) export ARCH="i386";;
1503 amd64) export ARCH="x86_64";;
1504 hppa) export ARCH="parisc";;
1505 mips) export ARCH="mips";;
1506 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1507 *) export ARCH="${ARCH}";;
1508 esac
1509}
1510
1511# set's ARCH back to what portage expects
1512set_arch_to_portage() {
1513 i=10
1514 while ((i--)) ; do
1515 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1516 done
1517 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1518}
1519
1520# Jeremy Huddleston <eradicator@gentoo.org>:
1521# preserve_old_lib /path/to/libblah.so.0
1522# preserve_old_lib_notify /path/to/libblah.so.0
1523#
1524# These functions are useful when a lib in your package changes --library. Such 1738# These functions are useful when a lib in your package changes ABI SONAME.
1525# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1739# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1526# would break packages that link against it. Most people get around this 1740# would break packages that link against it. Most people get around this
1527# by using the portage SLOT mechanism, but that is not always a relevant 1741# by using the portage SLOT mechanism, but that is not always a relevant
1528# solution, so instead you can add the following to your ebuilds: 1742# solution, so instead you can call this from pkg_preinst. See also the
1529# 1743# preserve_old_lib_notify function.
1530# src_install() {
1531# ...
1532# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1533# ...
1534# }
1535#
1536# pkg_postinst() {
1537# ...
1538# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1539# ...
1540# }
1541
1542preserve_old_lib() { 1744preserve_old_lib() {
1543 LIB=$1 1745 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1746 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1747 die "Invalid preserve_old_lib() usage"
1748 fi
1749 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1544 1750
1545 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1751 # let portage worry about it
1546 SONAME=`basename ${LIB}` 1752 has preserve-libs ${FEATURES} && return 0
1547 DIRNAME=`dirname ${LIB}`
1548 1753
1549 dodir ${DIRNAME} 1754 local lib dir
1550 cp ${ROOT}${LIB} ${D}${DIRNAME} 1755 for lib in "$@" ; do
1756 [[ -e ${ROOT}/${lib} ]] || continue
1757 dir=${lib%/*}
1758 dodir ${dir} || die "dodir ${dir} failed"
1759 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1551 touch ${D}${LIB} 1760 touch "${D}"/${lib}
1552 fi 1761 done
1553} 1762}
1554 1763
1764# @FUNCTION: preserve_old_lib_notify
1765# @USAGE: <libs to notify> [more libs]
1766# @DESCRIPTION:
1767# Spit helpful messages about the libraries preserved by preserve_old_lib.
1555preserve_old_lib_notify() { 1768preserve_old_lib_notify() {
1556 LIB=$1 1769 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1770 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1771 die "Invalid preserve_old_lib_notify() usage"
1772 fi
1557 1773
1558 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1774 # let portage worry about it
1559 SONAME=`basename ${LIB}` 1775 has preserve-libs ${FEATURES} && return 0
1560 1776
1777 local lib notice=0
1778 for lib in "$@" ; do
1779 [[ -e ${ROOT}/${lib} ]] || continue
1780 if [[ ${notice} -eq 0 ]] ; then
1781 notice=1
1561 ewarn "An old version of an installed library was detected on your system." 1782 ewarn "Old versions of installed libraries were detected on your system."
1562 ewarn "In order to avoid breaking packages that link against it, this older version" 1783 ewarn "In order to avoid breaking packages that depend on these old libs,"
1563 ewarn "is not being removed. In order to make full use of this newer version," 1784 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1564 ewarn "you will need to execute the following command:" 1785 ewarn "in order to remove these old dependencies. If you do not have this"
1786 ewarn "helper program, simply emerge the 'gentoolkit' package."
1787 ewarn
1788 fi
1565 ewarn " revdep-rebuild --library ${SONAME}" 1789 ewarn " # revdep-rebuild --library ${lib##*/}"
1790 done
1791 if [[ ${notice} -eq 1 ]] ; then
1566 ewarn 1792 ewarn
1567 ewarn "After doing that, you can safely remove ${LIB}" 1793 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1568 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1794 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1795 for lib in "$@" ; do
1796 ewarn " # rm '${lib}'"
1797 done
1569 fi 1798 fi
1570} 1799}
1571 1800
1572# Hack for people to figure out if a package was built with 1801# @FUNCTION: built_with_use
1573# certain USE flags 1802# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1803# @DESCRIPTION:
1574# 1804#
1575# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1805# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1576# ex: built_with_use xchat gtk2
1577# 1806#
1578# Flags: -a all USE flags should be utilized 1807# A temporary hack until portage properly supports DEPENDing on USE
1579# -o at least one USE flag should be utilized 1808# flags being enabled in packages. This will check to see if the specified
1580# Note: the default flag is '-a' 1809# DEPEND atom was built with the specified list of USE flags. The
1810# --missing option controls the behavior if called on a package that does
1811# not actually support the defined USE flags (aka listed in IUSE).
1812# The default is to abort (call die). The -a and -o flags control
1813# the requirements of the USE flags. They correspond to "and" and "or"
1814# logic. So the -a flag means all listed USE flags must be enabled
1815# while the -o flag means at least one of the listed IUSE flags must be
1816# enabled. The --hidden option is really for internal use only as it
1817# means the USE flag we're checking is hidden expanded, so it won't be found
1818# in IUSE like normal USE flags.
1819#
1820# Remember that this function isn't terribly intelligent so order of optional
1821# flags matter.
1581built_with_use() { 1822built_with_use() {
1823 local hidden="no"
1824 if [[ $1 == "--hidden" ]] ; then
1825 hidden="yes"
1826 shift
1827 fi
1828
1829 local missing_action="die"
1830 if [[ $1 == "--missing" ]] ; then
1831 missing_action=$2
1832 shift ; shift
1833 case ${missing_action} in
1834 true|false|die) ;;
1835 *) die "unknown action '${missing_action}'";;
1836 esac
1837 fi
1838
1582 local opt=$1 1839 local opt=$1
1583 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1840 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1584 1841
1585 local PKG=$(best_version $1) 1842 local PKG=$(best_version $1)
1586 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package" 1843 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1587 shift 1844 shift
1588 1845
1589 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1846 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1847 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1590 1848
1591 # if the USE file doesnt exist, assume the $PKG is either 1849 # if the IUSE file doesn't exist, the read will error out, we need to handle
1592 # injected or package.provided 1850 # this gracefully
1851 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1852 case ${missing_action} in
1853 true) return 0;;
1854 false) return 1;;
1593 [[ ! -e ${USEFILE} ]] && die "Unable to determine what USE flags $PKG was built with" 1855 die) die "Unable to determine what USE flags $PKG was built with";;
1856 esac
1857 fi
1858
1859 if [[ ${hidden} == "no" ]] ; then
1860 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1861 # Don't check USE_EXPAND #147237
1862 local expand
1863 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1864 if [[ $1 == ${expand}_* ]] ; then
1865 expand=""
1866 break
1867 fi
1868 done
1869 if [[ -n ${expand} ]] ; then
1870 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1871 case ${missing_action} in
1872 true) return 0;;
1873 false) return 1;;
1874 die) die "$PKG does not actually support the $1 USE flag!";;
1875 esac
1876 fi
1877 fi
1878 fi
1594 1879
1595 local USE_BUILT=$(<${USEFILE}) 1880 local USE_BUILT=$(<${USEFILE})
1596 while [[ $# -gt 0 ]] ; do 1881 while [[ $# -gt 0 ]] ; do
1597 if [[ ${opt} = "-o" ]] ; then 1882 if [[ ${opt} = "-o" ]] ; then
1598 has $1 ${USE_BUILT} && return 0 1883 has $1 ${USE_BUILT} && return 0
1602 shift 1887 shift
1603 done 1888 done
1604 [[ ${opt} = "-a" ]] 1889 [[ ${opt} = "-a" ]]
1605} 1890}
1606 1891
1892# @FUNCTION: epunt_cxx
1893# @USAGE: [dir to scan]
1894# @DESCRIPTION:
1607# Many configure scripts wrongly bail when a C++ compiler 1895# Many configure scripts wrongly bail when a C++ compiler could not be
1608# could not be detected. #73450 1896# detected. If dir is not specified, then it defaults to ${S}.
1897#
1898# http://bugs.gentoo.org/73450
1609epunt_cxx() { 1899epunt_cxx() {
1610 local dir=$1 1900 local dir=$1
1611 [[ -z ${dir} ]] && dir=${S} 1901 [[ -z ${dir} ]] && dir=${S}
1612 ebegin "Removing useless C++ checks" 1902 ebegin "Removing useless C++ checks"
1613 local f 1903 local f
1614 for f in $(find ${dir} -name configure) ; do 1904 find "${dir}" -name configure | while read f ; do
1615 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1905 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1616 done 1906 done
1617 eend 0 1907 eend 0
1618} 1908}
1619 1909
1620# dopamd <file> [more files] 1910# @FUNCTION: make_wrapper
1621# 1911# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1622# Install pam auth config file in /etc/pam.d 1912# @DESCRIPTION:
1623dopamd() { 1913# Create a shell wrapper script named wrapper in installpath
1624 [[ -z $1 ]] && die "dopamd requires at least one argument" 1914# (defaults to the bindir) to execute target (default of wrapper) by
1625 1915# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1626 use pam || return 0 1916# libpaths followed by optionally changing directory to chdir.
1627
1628 INSDESTTREE=/etc/pam.d \
1629 doins "$@" || die "failed to install $@"
1630}
1631# newpamd <old name> <new name>
1632#
1633# Install pam file <old name> as <new name> in /etc/pam.d
1634newpamd() {
1635 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1636
1637 use pam || return 0
1638
1639 INSDESTTREE=/etc/pam.d \
1640 newins "$1" "$2" || die "failed to install $1 as $2"
1641}
1642
1643# make a wrapper script ...
1644# NOTE: this was originally games_make_wrapper, but I noticed other places where
1645# this could be used, so I have moved it here and made it not games-specific
1646# -- wolf31o2
1647# $1 == wrapper name
1648# $2 == binary to run
1649# $3 == directory to chdir before running binary
1650# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1651# $5 == path for wrapper
1652make_wrapper() { 1917make_wrapper() {
1653 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1918 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1654 local tmpwrapper=$(emktemp) 1919 local tmpwrapper=$(emktemp)
1655 # We don't want to quote ${bin} so that people can pass complex 1920 # We don't want to quote ${bin} so that people can pass complex
1656 # things as $bin ... "./someprog --args" 1921 # things as $bin ... "./someprog --args"
1666fi 1931fi
1667exec ${bin} "\$@" 1932exec ${bin} "\$@"
1668EOF 1933EOF
1669 chmod go+rx "${tmpwrapper}" 1934 chmod go+rx "${tmpwrapper}"
1670 if [[ -n ${path} ]] ; then 1935 if [[ -n ${path} ]] ; then
1936 (
1671 exeinto "${path}" 1937 exeinto "${path}"
1672 newexe "${tmpwrapper}" "${wrapper}" 1938 newexe "${tmpwrapper}" "${wrapper}"
1939 ) || die
1673 else 1940 else
1674 newbin "${tmpwrapper}" "${wrapper}" 1941 newbin "${tmpwrapper}" "${wrapper}" || die
1942 fi
1943}
1944
1945# @FUNCTION: prepalldocs
1946# @USAGE:
1947# @DESCRIPTION:
1948# Compress files in /usr/share/doc which are not already
1949# compressed, excluding /usr/share/doc/${PF}/html.
1950# Uses the ecompressdir to do the compression.
1951# 2009-02-18 by betelgeuse:
1952# Commented because ecompressdir is even more internal to
1953# Portage than prepalldocs (it's not even mentioned in man 5
1954# ebuild). Please submit a better version for review to gentoo-dev
1955# if you want prepalldocs here.
1956#prepalldocs() {
1957# if [[ -n $1 ]] ; then
1958# ewarn "prepalldocs: invalid usage; takes no arguments"
1675 fi 1959# fi
1676} 1960
1961# cd "${D}"
1962# [[ -d usr/share/doc ]] || return 0
1963
1964# find usr/share/doc -exec gzip {} +
1965# ecompressdir --ignore /usr/share/doc/${PF}/html
1966# ecompressdir --queue /usr/share/doc
1967#}

Legend:
Removed from v.1.247  
changed lines
  Added in v.1.348

  ViewVC Help
Powered by ViewVC 1.1.20